<?php
/*
	@! MADISS
	@@ MAke DIgital Signage Simple
	@@ Version 2.0 (11/2017)
-----------------------------------------------------------------------------	
	** author: Benoît FACCHINETTI 
	** Site: http://benserveur.fr.cr/MADISS
	** email: benoitfacchinetti@gmail.com
-----------------------------------------------------------------------------
	@@package: PLAYER
	@@version: 1.0
*/
if(!defined('IN_MADISS')) die('Action impossible ! (erreur: Script could not be opened alone)'); //Vérifi si appeler par nos scripts

function API_GET($url){
	$page = file_get_contents($url);
	$data = json_decode($page, true);
	return $data;
}

function API_POST($url, $params = null){
	$curl = curl_init();
	/* exemple de params
	$params = [
		'title' => 'Welcome Bro !',
		'body' => 'Lorem Ipsum etc etc',
		'userId' => 5
	];
	*/
	if(is_array($params) && $params != null){
		$params_string = http_build_query($params);

		$opts = [
			CURLOPT_URL => $url,
			CURLOPT_POST => true,
			CURLOPT_POSTFIELDS => $params_string,
			CURLOPT_RETURNTRANSFER => true,
		];

		curl_setopt_array($curl, $opts);

		$out = json_decode(curl_exec($curl), true);
	}else{
		$out = false;
	}
	return $out;
}

function _GETCONFIG($file = null)
{
	if($file === null)
	{
		$file = __DIR__.DIRECTORY_SEPARATOR.'player_config.json';
	}
	if(file_exists($file))
	{
		$configuration = json_decode(file_get_contents($file), true);
		return $configuration;
	}else{ die('le fichier '.$file.' n\'existe pas !');}
}

function _PUTCONFIG($data_array, $file = null){
	if($file === null)
	{
		$file = __DIR__.DIRECTORY_SEPARATOR.'player_config.json';
	}
	if(file_exists($file) && is_array($data_array))
	{
		$arr = json_decode(file_get_contents($file), true);
		$output = array_replace($arr, $data_array);
		$joutput = json_encode($output);
		$createfile = file_put_contents($file, $joutput);
		
		return true;
	}else{ return false;}
}

function is_internet()
{
    $connected = @fsockopen("www.google.com", 80); 
                                        //website, port  (try 80 or 443)
    if ($connected){
        $is_conn = true; //action when connected
        fclose($connected);
    }else{
        $is_conn = false; //action in connection failure
    }
    return $is_conn;

}

function select_plugin($list_plugin){
	global $_SESSION;

	//liste des fichiers (plugins) actifs
	if(!is_array($_SESSION['last_page'])){$_SESSION['last_page'] = array();} //On definit la session en tableau
	
	$nb_plugin = count($list_plugin)-1; // On compte le nombre total de modules et pages

	foreach($list_plugin as $key => $name){
		//Si on à passer tout les modules on vide la session pour recommencer
		if(in_array($nb_plugin, $_SESSION['last_page'])){
			$_SESSION['last_page'] = array();
		}
		if(!in_array($key, $_SESSION['last_page'])){// On met a jour le tableau et on assigne le nouveau module à afficher
			$_SESSION['last_page'][] = $key;
			$plugin_selected = $name;
			break;
		}
	}
	$out = array('p_infos' => explode('.',basename($plugin_selected)), 'p_selected' => $plugin_selected);
	// Recupere les infos du module a afficher
	return $out;
}
function select_scrolling($list_slider){
	global $_SESSION;

	//liste des fichiers (plugins) actifs
	if(!is_array($_SESSION['last_slider'])){$_SESSION['last_slider'] = array();} //On definit la session en tableau

	$nb_slider = count($list_slider)-1; // On compte le nombre total de slider

	foreach($list_slider as $key => $name){
		//Si on à passer tout les slider on vide la session pour recommencer
		if(in_array($nb_slider, $_SESSION['last_slider'])){
			$_SESSION['last_slider'] = array();
		}
		if(!in_array($key, $_SESSION['last_slider'])){// On met a jour le tableau et on assigne le nouveau module à afficher
			$_SESSION['last_slider'][] = $key;
			$slider_selected = $name;
			break;
		}
	}
	$out = array('s_infos' => explode('.',basename($slider_selected)), 's_selected' => $slider_selected);
	// Recupere les infos du module a afficher
	return $out;
}

function Error($errorCode){
	
	if(is_numeric($errorCode)){
		$out = array();
		switch ($errorCode) {
		case 400:
			$out['ErrorMessage'] = 'Bad request : Error in server request.';
			break;
		case 401:
			$out['ErrorMessage'] = 'Unauthorized : Screen not activated.';
			break;
		case 403:
			$out['ErrorMessage'] = 'Forbident : Screen is not allowed in backend.';
			break;
		case 404:
			$out['ErrorMessage'] = 'Internet not found !';
			break;
		case 405:
			$out['ErrorMessage'] = 'Not found : "fullpagedashboard.txt" not found.';
			break;
		case 500:
			$out['ErrorMessage'] = 'Server error : Communication error with the server.';
			break;
		case 503:
			$out['ErrorMessage'] = 'Service Unavailable : no response from the API.';
			break;
		}
		$out['errorCode'] = $errorCode;
		return $out;
	}else{
		return false;
	
	}
}

function getIP() {
    $ip = $_SERVER['SERVER_ADDR'];

    if (PHP_OS == 'WINNT'){
        $ip = getHostByName(getHostName());
    }

    if (PHP_OS == 'Linux'){
        $command="/sbin/ifconfig";
        exec($command, $output);
        // var_dump($output);
        $pattern = '/inet ?([^ ]+)/';

        $ip = array();
        foreach ($output as $key => $subject) {
            $result = preg_match_all($pattern, $subject, $subpattern);
            if ($result == 1) {
                if ($subpattern[1][0] != "127.0.0.1")
                $ip = $subpattern[1][0];
				break;
            }
        //var_dump($subpattern);
        }
    }
    return $ip;
}
?>